#!/usr/bin/python

import re
import subprocess
import shlex
import time
import os.path
import sys
import syslog

containerName = ''
containerInput = sys.stdin.readline().strip()

if containerInput:
    syslog.syslog("Got container input '%s'." % (containerInput))
    reContainerName = re.match(r'\bcontainer_name=([a-zA-Z0-9\-_]+)', containerInput, re.M|re.I)
    if reContainerName:
        containerName = reContainerName.group(1)
    syslog.syslog("containerName='%s'." % (containerName))

if containerName:
    while True:
        containerNameFound = subprocess.check_output("docker ps --filter 'name=%s' --format '{{.Names}}'" % (containerName), shell=True)
        if containerNameFound:
            break
        else:
            syslog.syslog("Container happens to be not up yet, will wait 5 seconds and retry...")
            time.sleep(5)
else:
    while True:
        pgContainerName = subprocess.check_output("docker ps --filter 'name=PostgreSQL' --format '{{.Names}}'", shell=True)
        mysqlContainerName = subprocess.check_output("docker ps --filter 'name=MySQL' --format '{{.Names}}'", shell=True)
        if pgContainerName:
            containerName = pgContainerName
            break
        elif mysqlContainerName:
            containerName = mysqlContainerName
            break
        else:
            syslog.syslog("Container happens to be not up yet, will wait 5 seconds and retry...")
            time.sleep(5)

syslog.syslog("Configuring CNI for container '%s'." % (containerName))

cniDelPath = "/usr/local/bin/invokecnidel.sh"
cniAddPath = "/usr/local/bin/invokecniadd.sh"
delResult = "Not Executed DEL"
addResult = "Not Executed ADD"

if os.path.exists(cniDelPath):
    while delResult:
        try:
            delResult = subprocess.check_output(shlex.split(cniDelPath + " " + containerName + ' default'))
            syslog.syslog(("Delete Container Network Interface successfully. containerName='%s'.") % (containerName))
        except subprocess.CalledProcessError as grepExcDel:
            syslog.syslog(syslog.LOG_ERR, ("Failed to delete CNI. containerName='%s', err='%s'.") % (containerName, grepExcDel.output))
            time.sleep(2)

if os.path.exists(cniAddPath):
    while addResult:
        try:
            addResult = subprocess.check_output(shlex.split(cniAddPath + " " + containerName + ' default'))
            syslog.syslog(("Add Container Network Interface successfully. containerName='%s'.") % (containerName))
        except subprocess.CalledProcessError as grepExcAdd:
            syslog.syslog(syslog.LOG_ERR, ("Failed to add CNI. containerName='%s', err='%s'.") % (containerName, grepExcAdd.output))
            time.sleep(2)
